﻿//*************************************************}
//                                                 }
//       Class: TIDSendKey                         }
//       Programmed with Visual Studio 2008        }
//       Tectus Transponder Technology GmbH        }
//       Sascha Haveloh, s.haveloh@tec-tus.de      }
//                                                 }
//*************************************************}


using System;
using System.Linq;
using System.Collections.Generic;
using System.Text;
using System.Runtime;
using System.Runtime.InteropServices;
using System.Threading;
using System.IO;

public class TIDSendKey
{

    public TIDSendKey()
    {
        New_Init();
    }

    private void New_Init()
    { 
    }

    ~TIDSendKey()
    {
        New_DeInit();
    }

    public void New_DeInit()
    {

    }

    const int KEYEVENTF_KEYPRESS = 0x0000;
    const int WM_SETFOCUS = 0x7;
    const int WM_SETTEXT = 0xc;
    const int WM_SYSKEYDOWN = 0x104;
    const int WM_SYSKEYUP = 0x105;
    const int WM_KEYDOWN = 0x100;
    const int WM_KEYUP = 0x101;
    const int KEYEVENTF_KEYUP = 0x02;
    const int VK_CAPITAL = 20;
    const int VK_SHIFT = 0x10;
    const int VK_RETURN = 13;



    [DllImport("coredll.dll", EntryPoint = "keybd_event", SetLastError = true)]
    internal static extern void keybd_event(byte bVk, byte bScan, int dwFlags, int dwExtraInfo);


    private int HiByte(int W)
    {
        return W >> 8;
    }

    private void SimulateKeystroke(byte Key, byte extra)
    {
        keybd_event(Key, extra, 0, 0);
        keybd_event(Key, extra, KEYEVENTF_KEYUP, 0);
    }

    private void SimulateKeyDown(byte Key)
    {
        keybd_event(Key, 0, 0, 0);
    }

    private void SimulateKeyUp(byte Key)
    {
        keybd_event(Key, 0, KEYEVENTF_KEYUP, 0);
    }


    public bool SendCEKeys(string s, string AddOn, string CharTimeOut)
    {
        bool functionReturnValue = false;
        int i = 0;
        byte w = 0;
        int t = 0;
        functionReturnValue = true;
        if (!string.IsNullOrEmpty(CharTimeOut))
        {
            try
            {
                t = Convert.ToInt32(CharTimeOut);
            }
            catch (Exception ex)
            {
                t = 0;
            }
        }
        try
        {
            for (i = 0; i <= s.Length -1; i++)
            {
                w = (byte)Convert.ToChar(s.Substring(i, 1));
                if (!string.IsNullOrEmpty(CharTimeOut))
                {
                    if (t > 0)
                        System.Threading.Thread.Sleep(t);
                }
                if ((w >= 47 & w <= 57))
                {
                    SimulateKeystroke(w, 0);
                }
                else
                {
                    SimulateKeyDown(VK_SHIFT);
                    SimulateKeystroke(w, 0);
                    SimulateKeyUp(VK_SHIFT);
                }
            }
            if (!string.IsNullOrEmpty(AddOn))
            {
                w = (byte)Convert.ToChar(AddOn); 
                SimulateKeystroke(w, 0);
            }
        }
        catch (Exception ex)
        {
            functionReturnValue = false;
        }
        return functionReturnValue;
    }



}
