﻿using System;
using System.Linq;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace RFID_Demo
{
    public partial class frmHF : Form
    {
        frmMain fc;
        public frmHF(frmMain fc)
        {
            InitializeComponent();
            this.fc = fc;
        }
        public bool IsKeyAction;


        public void InfoAdd(string Value)
        {
            try
            {
                if (string.IsNullOrEmpty(Value))
                {
                    return;
                }
                ListBox1.Items.Add(Value);
                ListBox1.SelectedIndex = ListBox1.Items.Count - 1;
                if (ListBox1.Items.Count >= 1000)
                {
                    ListBox1.Items.Clear();
                }
            }
            catch (Exception ex)
            {
                //            WriteErrorFile(ex.Message)
            }

        }

        public bool ReadTransponder()
        {
            bool Result = false;
            IsKeyAction = true;
            btReadTransponder_Click(null, null);
            IsKeyAction = false;
            Result = true;
            return Result;
        }


        private void  ExitItem_Click(object sender, EventArgs e)
        {
            if (cbConti.Checked)
            {
                cbConti.Checked = false;
                InfoAdd("Stop Continues Read");
            }
            if (MessageBox.Show("Close Form ?", this.Text, MessageBoxButtons.YesNo, MessageBoxIcon.Question, MessageBoxDefaultButton.Button1) == DialogResult.Yes)
            {
               Close();
            }
        }

        private void MenuItem1_Click(object sender, EventArgs e)
        {
            ListBox1.Items.Clear();
        }

        private void btReadTransponder_Click(object sender, EventArgs e)
        {
            try
            {
                btReadTransponder.Enabled = false;
                btReadWriteData.Enabled = false;
                btGetVersion.Enabled = false;
                if (cbConti.Checked)
                {
                    InfoAdd("Start Continues Read");
                }
                do
                {
                    System.Windows.Forms.Application.DoEvents();
                    if (lbReaderInfo.Text == "No Reader") {lbReaderInfo.Text = fc.RFID_HF.GetVersion();}
                    if (fc.HF_Transponder_Typ == 0)  // ISO
                    {
                        if (fc.RFID_HF.GetUID_ISO())
                        {
                            InfoAdd("TAG-Nr. :" + fc.RFID_HF.UIDFeigNr_ISO);
                            fc.PlaySound();
                            fc.SendUIDNr(fc.RFID_HF.UIDFeigNr_ISO);
                        }
                        else
                        {
                            InfoAdd(fc.RFID_HF.ErrorText + "-No ISO 15693 found");
                        }
                    }
                    if (fc.HF_Transponder_Typ == 1)  // Mifare
                    {
                        if (fc.RFID_HF.GetUID_MIF())
                        {
                            InfoAdd("TAG-Nr. :" + fc.RFID_HF.UIDFeigNr_MIF);
                            fc.PlaySound();
                            fc.SendUIDNr(fc.RFID_HF.UIDFeigNr_MIF);
                         }
                         else
                         {
                             InfoAdd(fc.RFID_HF.ErrorText+ "-No ISO 14443 (Mifare)found");
                         }
                     }

                } while (cbConti.Checked);
            }
            finally
            {
                btReadTransponder.Enabled = true;
                btReadWriteData.Enabled = true;
                btGetVersion.Enabled = true;
            }
        }

        private void btGetVersion_Click(object sender, EventArgs e)
        {
            string Version = "";
            Version = fc.RFID_HF.GetVersion();
            lbReaderInfo.Text = Version;
            InfoAdd(Version);
        }

        private void btReadWriteData_Click(object sender, EventArgs e)
        {
            string myRes = string.Empty;
            string tmpHex = string.Empty; 
            int tmpBlock = Convert.ToInt32(NumBlock.Value);
            try
            {
                btReadTransponder.Enabled = false;
                btReadWriteData.Enabled = false;
                btGetVersion.Enabled = false;
                if (cbReadWriteBox.SelectedIndex == 0)
                {
                    InfoAdd("Read Data");
                    InfoAdd("Search UID");
                    if (fc.HF_Transponder_Typ == 0) // ISO15693 Transponder
                    {
                        if (fc.RFID_HF.GetUID_ISO())
                        {
                            InfoAdd("TAG-Nr. :" + fc.RFID_HF.UIDFeigNr_ISO);
                            fc.PlaySound();
                            txtData.Text = "";
                            myRes = fc.RFID_HF.ReadTagBlock_ISO(tmpBlock.ToString("X2"), "02");  // 2 Blocks = 2 x 4 Bytes = 8 Bytes, 8 ASCII digits or 16 digits HEX
                            if (fc.RFID_HF.ErrorID == 0)
                            {
                                InfoAdd(myRes);
                                tmpHex = fc.RFID_HF.GetSplitBlockData(tmpBlock.ToString("X2"), "02", myRes); // Split 
                                txtData.Text = fc.RFID_HF.HexToASCII(tmpHex); // 31.01.2013  
                                InfoAdd("Read = OK");
                            }
                            else
                            {
                                InfoAdd(fc.RFID_HF.ErrorText);
                                InfoAdd("No Data found");
                            }
                        }
                        else
                        {
                            InfoAdd(fc.RFID_HF.ErrorText+"-No ISO 15693 found");
                        }
                    }
                    if (fc.HF_Transponder_Typ == 1)
                    {
                        if (fc.RFID_HF.GetUID_MIF())
                        {
                            InfoAdd("TAG-Nr. :" + fc.RFID_HF.UIDFeigNr_MIF);
                            fc.PlaySound();
                            txtData.Text = "";
                            myRes = fc.RFID_HF.ReadTagBlock_MIF(tmpBlock.ToString("X2"), "02");  // 2 Blocks = 2 x 4 Bytes = 8 Bytes, 8 ASCII digits or 16 digits HEX
                            if (fc.RFID_HF.ErrorID == 0)
                            {
                                InfoAdd(myRes);
                                tmpHex = fc.RFID_HF.GetSplitBlockData(tmpBlock.ToString("X2"), "02", myRes); // Split 
                                txtData.Text = fc.RFID_HF.HexToASCII(tmpHex); // 31.01.2013  
                                InfoAdd("Read = OK");
                            }
                            else
                            {
                                InfoAdd(fc.RFID_HF.ErrorText+"No Data found");
                            }
                        }
                        else
                        {
                            InfoAdd(fc.RFID_HF.ErrorText+"-No ISO 14443 (Mifare)found");
                        }

                    }
                }
                if (cbReadWriteBox.SelectedIndex == 1)
                {
                    InfoAdd("Write Data");
                    InfoAdd("Search UID");
                    if (fc.HF_Transponder_Typ == 0)
                    {
                        if (fc.RFID_HF.GetUID_ISO())
                        {
                            InfoAdd("TAG-Nr. :" + fc.RFID_HF.UIDFeigNr_ISO);
                            fc.PlaySound();
                            for (int i = txtData.Text.Length; i < 8; i++) {txtData.Text += " ";}

                            tmpHex = fc.RFID_HF.ASCIIToHex(txtData.Text);
                            myRes = fc.RFID_HF.WriteTagBlock_ISO(tmpBlock.ToString("X2"), "02", tmpHex);// 2 Blocks = 2 x 4 Bytes = 8 Bytes, 8 ASCII digits or 16 digits HEX
                            if (fc.RFID_HF.ErrorID == 0)
                            {
                                InfoAdd(myRes);
                                InfoAdd("Write = OK");
                            }
                            else
                            {
                                InfoAdd(fc.RFID_HF.ErrorText);
                                InfoAdd("Write = ERROR");
                            }
                        }
                        else
                        {
                            InfoAdd(fc.RFID_HF.ErrorText+"-No ISO 15693 found");
                        }

                    }
                    if (fc.HF_Transponder_Typ == 1)
                    {
                        if (fc.RFID_HF.GetUID_MIF())
                        {
                            InfoAdd("TAG-Nr. :" + fc.RFID_HF.UIDFeigNr_MIF);
                            fc.PlaySound();
                            for (int i = txtData.Text.Length; i < 8; i++) { txtData.Text += " "; }

                            tmpHex = fc.RFID_HF.ASCIIToHex(txtData.Text);
                            myRes = fc.RFID_HF.WriteTagBlock_MIF(tmpBlock.ToString("X2"), "02", tmpHex);// 2 Blocks = 2 x 4 Bytes = 8 Bytes, 8 ASCII digits or 16 digits HEX
                            if (fc.RFID_HF.ErrorID == 0)
                            {
                                InfoAdd(myRes);
                                InfoAdd("Write = OK");
                            }
                            else
                            {
                                InfoAdd(fc.RFID_HF.ErrorText);
                                InfoAdd("Write = ERROR");
                            }
                        }
                        else
                        {
                            InfoAdd(fc.RFID_HF.ErrorText+"-No ISO 14443 (Mifare)found");
                        }
                    }
                }
            }
            finally
            {
                btReadTransponder.Enabled = true;
                btReadWriteData.Enabled = true;
                btGetVersion.Enabled = true;
            }
        }

        private void frmHF_Load(object sender, System.EventArgs e)
        {
            cbReadWriteBox.SelectedIndex = 0;
            TagView.SelectedIndex = 0;
            TagView_SelectedIndexChanged(null, null);
        }

        private void cbReadWriteBox_SelectedIndexChanged(object sender, EventArgs e)
        {
            btReadWriteData.Text = cbReadWriteBox.Text;
        }

        private void  ClearItem_Click(System.Object sender, System.EventArgs e)
        {
            ListBox1.Items.Clear();
        }


        private void cbConti_CheckStateChanged(System.Object sender, System.EventArgs e)
        {
        }

        private void TagView_SelectedIndexChanged(object sender, EventArgs e)
        {
            fc.HF_Transponder_Typ = TagView.SelectedIndex;
            //HF_TagTyp = 0 - ISO 15693, HF_TagTyp = 1 - Mifare 14443
        }

        private void EventItem_Click(object sender, EventArgs e)
        {
            EventItem.Checked = !EventItem.Checked;
        }

        private void menuItem1_Click_1(object sender, EventArgs e)
        {
            if (cbConti.Checked)
            {
                cbConti.Checked = false;
            }
            this.Hide();
            fc.Hide();
            fc.Tray1.InitialDuration = 0;
            fc.Tray1.Visible = true;
        }

        private void ChangeHF_Click(object sender, EventArgs e)
        {
            ListBox1.Items.Clear();
            InfoAdd("Close Reader");
            fc.CloseReader(0);
            MessageBox.Show("Please change the HF-Reader." + '\r' + "Then they press OK.", this.Text, MessageBoxButtons.OK, MessageBoxIcon.Question, MessageBoxDefaultButton.Button2);
            fc.PlaySound();
            fc.Reader_Typ = 2;
            InfoAdd("Check HF-Reader");
            fc.CheckReaderOnBoard();
            if (fc.RFID_HF.Active)
            {
                InfoAdd("HF-Reader found");
                InfoAdd("Check Version");
            }
            else
            {
                InfoAdd("ERROR: No HF-Reader found");
            }
            btGetVersion_Click(null, null);
        }

    }
}