﻿using System;
using System.Linq;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace RFID_Demo
{
    public partial class frmRFIDData : Form
    {
        frmMain fc; // Info...
        public frmRFIDData(frmMain fc)
        {
            InitializeComponent();
            this.fc = fc; 
        }
        
        	// WHERE ([VarField1] = @p1)"
        const string UpdateSql = "UPDATE [tblDaten] SET [VarField1] = @p1, [VarField2] = @p2, [VarField3] = @p3, [VarField4] = @p4, [VarField5] = @p5 ";

        const string InsertSql = "INSERT INTO [tblDaten] ([VarField1], [VarField2], [VarField3], [VarField4], [VarField5]) VALUES (@p1, @p2, @p3, @p4, @p5)";
        string DBStatus;
        System.DateTime thisDate;

        public string TagInfo;

        public frmData frmDataDlg;

        private void ExitItem_Click(Object sender, EventArgs e)
        {
            if (MessageBox.Show("Close Form ?",this.Text,MessageBoxButtons.YesNo,MessageBoxIcon.Question,MessageBoxDefaultButton.Button1) == DialogResult.Yes)     
            {
                Close();
            }
        }

        private void DataItem_Click(Object sender, EventArgs e)
        {
            int rcount = 0;
            frmData frmDataDlg = new frmData(this.fc);
            fc.CloseConnection();
            fc.OpenConnection();
            if (fc.conn_bar.State == ConnectionState.Open)
            {
                fc.SC(1);
                frmDataDlg.DataGrid1.DataSource = null;
                //DataGrid1.DataSource = Nothing
                rcount = fc.GetRecordCount();
                frmDataDlg.CountLabel1.Text = rcount.ToString();
                frmDataDlg.LabelI1.Text = "Data:";
                if (rcount > 0)
                {
                    //SetPanel(4)
                    fc.cmd_bar.CommandText = "Select * from tblDaten";
                    fc.rs_bar.SelectCommand = fc.cmd_bar;
                    fc.ds_bar.Clear();
                    fc.rs_bar.Fill(fc.ds_bar, "tblDaten");
                    frmDataDlg.DataGrid1.ColumnHeadersVisible = true;
                    frmDataDlg.DataGrid1.DataSource = fc.ds_bar.Tables["tblDaten"];
                }
                else
                {
                    //frmDataDlg.bbDatenLoeschen.Enabled = False
                }
                fc.SC(0);
                frmDataDlg.ShowDialog();
                if ((frmDataDlg != null))
                {
                    frmDataDlg.Dispose();
                    frmDataDlg = null;
                }
            }
        }

        private bool FindTAGInTable(string TagNr)
        {
            bool functionReturnValue = false;
            string Sql = string.Empty;  
            System.DateTime s = System.DateTime.Now; 
            int rcount = 0;
            fc.CloseConnection();
            fc.OpenConnection();
            if (fc.conn_bar.State == ConnectionState.Open)
            {
                Sql = "SELECT * FROM tblDaten WHERE VarField1 = '" + TagNr + "'";
                fc.cmd_bar.CommandText = Sql;
                fc.rs_bar.SelectCommand = fc.cmd_bar;
                fc.ds_bar.Clear();
                rcount = fc.rs_bar.Fill(fc.ds_bar, "tblDaten");
                if (rcount > 0)
                {
                    DataRow dr_auf = fc.ds_bar.Tables["tblDaten"].NewRow();
                    dr_auf = fc.ds_bar.Tables["tblDaten"].Select("VarField1='" + TagNr + "'")[0];
                    functionReturnValue = true;
                    // The data comes from Transponder
                    if ((fc.TagType == 1) | (fc.TagType == 3))
                    {
                        // txtBox2.Text = dr_auf("VarField2").ToString
                    }
                    else
                    {
                        txtBox2.Text = dr_auf["VarField2"].ToString();
                    }
                    txtBox3.Text = dr_auf["VarField3"].ToString();
                    txtBox4.Text = dr_auf["VarField4"].ToString();
                    txtBox5.Text = dr_auf["VarField5"].ToString();
                    dr_auf = null;
                    fc.CloseConnection();
                }
            }
            return functionReturnValue;
        }

        private bool ReadTagDataUHF()
        {
            string tmpField1 = string.Empty;
            bool Result = false;
            tmpField1 = "";
            if (fc.RFID_UHF.ReadTagBlock24_UHF(3, 4, 0)) 
            {
                tmpField1 = fc.RFID_UHF.BlockDataAScII;
            }
            txtBox2.Text = tmpField1;
            return Result;
        }

        private bool ReadTagDataHF()
        {
            string tmpField1 = string.Empty;
            string myRes = string.Empty; 
            bool Result = false;
            tmpField1 = "";

            if (fc.HF_Transponder_Typ == 0)
            {
                myRes = fc.RFID_HF.ReadTagBlock_ISO("10", "2");
                if (fc.RFID_HF.ErrorID == 0) 
                {
                    tmpField1 = fc.RFID_HF.GetSplitBlockData("10", "2", myRes);
                    Result = true;
                }
            }
            txtBox2.Text = fc.RFID_HF.HexToASCII(tmpField1); 
            return Result;
        }

        private bool ReadTagDataLF()
        {
            string tmpField1 = "";
            bool Result = false;
            string Res1 = "";
            string Res2 = "";
            switch (fc.TagType)
            {
                case 1:
                    // HitagS
                    Res1 = fc.MyBTLF.ReadTagData(fc.TagType, "10");
                    Res2 = fc.MyBTLF.ReadTagData(fc.TagType, "11");
                    if ((Res1.Length >= 8) & (Res2.Length >= 8))
                    {
                        tmpField1 = Res1 + Res2;
                        Result = true;
                    }
                    tmpField1 = fc.MyBTLF.HexToASCII(tmpField1);
                    txtBox2.Text = tmpField1;
                    break;
                case 3:
                    // Q5/5557
                    Res1 = fc.MyBTLF.ReadTagData(fc.TagType, "10");
                    Res2 = fc.MyBTLF.ReadTagData(fc.TagType, "11");
                    if ((Res1.Length >= 8) & (Res2.Length >= 8))
                    {
                        tmpField1 = Res1 + Res2;
                        Result = true;
                    }
                    tmpField1 = fc.MyBTLF.HexToASCII(tmpField1);
                    txtBox2.Text = tmpField1;
                    break;
                case 7:
                    // EM4450/4550 (TITAN)-RW
                    Res1 = fc.MyBTLF.ReadTagData(fc.TagType, "10");
                    Res2 = fc.MyBTLF.ReadTagData(fc.TagType, "11");
                    if ((Res1.Length >= 8) & (Res2.Length >= 8))
                    {
                        tmpField1 = Res1 + Res2;
                        Result = true;
                    }
                    tmpField1 = fc.MyBTLF.HexToASCII(tmpField1);
                    txtBox2.Text = tmpField1;
                    break;
            }
            return Result;
        }


        private bool WriteTagDataHF()
        {
            bool Result = false;
            string tmpField1 = string.Empty;  
            for (int i = txtBox2.Text.Length; i < 8; i++) { txtBox2.Text += " "; }
            tmpField1 = fc.RFID_HF.ASCIIToHex(txtBox2.Text);   
            if (fc.HF_Transponder_Typ == 0) {fc.RFID_HF.WriteTagBlock_ISO("10", "02",tmpField1);}
            if (fc.HF_Transponder_Typ == 1) {fc.RFID_HF.WriteTagBlock_MIF("10", "02", tmpField1);}

            Result = (fc.RFID_HF.ErrorID == 0);
            return Result;
        }


        private bool WriteTagDataUHF()
        {
            bool Result = false;
            string tmpField1 = string.Empty;
            int i = 0;
            tmpField1 = txtBox2.Text;
            for (i = tmpField1.Length; i <= 8 - 1; i++)
            {
                 tmpField1 = tmpField1 + " ";
            }
            //tmpField1 = fc.RFID_UHF.ASCIIToHex(tmpField1)
            if (tmpField1.Length == 8)
            {
                Result = fc.RFID_UHF.WriteTagBlock24_UHF(3, 4, fc.RFID_UHF.ASCIIToHex(tmpField1), 0);
            }
            return Result;
        }

        private bool WriteTagDataLF()
        {
            //0 - EM 41xx (UNIQUE) - RO
            //1 - HITAG S - RW
            //2 - FDX-B ISO 11784/5-RO
            //3 - Q5 / 5557 -- RW
            //4 - HDX Transponder (TI)-RW
            //5 - HITAG 2 - RW
            //6 - EM 4305 - RW
            //7 - EM4450/4550 (TITAN)-RW

            string tmpField1 = string.Empty; 
            bool Result = false;
            string Res1 = string.Empty;
            string Res2 = string.Empty;
            int i = 0;
            switch (fc.TagType)
            {
                case 1:
                    // HitagS
                    tmpField1 = txtBox2.Text;
                    for (i = tmpField1.Length; i <= 8 - 1; i++)
                    {
                        tmpField1 = tmpField1 + " ";
                    }

                    tmpField1 = fc.MyBTLF.ASCIIToHex(tmpField1);
                    if (tmpField1.Length == 16)
                    {
                        Res1 = fc.MyBTLF.WriteTagData(fc.TagType, "10", tmpField1.Substring(0, 8));
                        Res2 = fc.MyBTLF.WriteTagData(fc.TagType, "11", tmpField1.Substring(8, 8));
                    }
                    break;
                case 3:
                    // Q5/5557
                    tmpField1 = txtBox2.Text;
                    for (i = tmpField1.Length; i <= 8 - 1; i++)
                    {
                        tmpField1 = tmpField1 + " ";
                    }

                    tmpField1 = fc.MyBTLF.ASCIIToHex(tmpField1);
                    if (tmpField1.Length == 16)
                    {
                        Res1 = fc.MyBTLF.WriteTagData(fc.TagType, "10", tmpField1.Substring(0, 8));
                        Res2 = fc.MyBTLF.WriteTagData(fc.TagType, "11", tmpField1.Substring(8, 8));
                    }
                    break;
                case 7:
                    //EM4450/4550 (TITAN)-RW
                    tmpField1 = txtBox2.Text;
                    for (i = tmpField1.Length; i <= 8 - 1; i++)
                    {
                        tmpField1 = tmpField1 + " ";
                    }

                    tmpField1 = fc.MyBTLF.ASCIIToHex(tmpField1);
                    if (tmpField1.Length == 16)
                    {
                        Res1 = fc.MyBTLF.WriteTagData(fc.TagType, "10", tmpField1.Substring(0, 8));
                        Res2 = fc.MyBTLF.WriteTagData(fc.TagType, "11", tmpField1.Substring(8, 8));
                    }
                    break;
            }
            Result = (Res1 == "+") & (Res2 == "+");
            return Result;
        }

        private bool WriteDataToDataBase(string TagNr)
        {
            string tmpTAG = TagNr;
            bool IsNewDataSet = false;
            System.DateTime s = System.DateTime.Now;
            int rcount = 0;
            bool ResultWriteDataToDataBase = false;
            IsNewDataSet = DBStatus == "AddNew";
            fc.CloseConnection();
            fc.OpenConnection();
            if (!(fc.conn_bar.State == ConnectionState.Open))
            {
                fc.CloseConnection();
                return ResultWriteDataToDataBase;
            }

            fc.cmd_bar.CommandText = "SELECT * FROM tblDaten WHERE VarField1 = '" + TagNr + "'";
            fc.rs_bar.SelectCommand = fc.cmd_bar;

            System.Data.SqlServerCe.SqlCeCommandBuilder cb = new System.Data.SqlServerCe.SqlCeCommandBuilder(fc.rs_bar);
            fc.rs_bar.InsertCommand = cb.GetInsertCommand();
            fc.rs_bar.UpdateCommand = cb.GetInsertCommand();
            fc.rs_bar.UpdateCommand.CommandText = UpdateSql + " WHERE ([VarField1] = '" + TagNr + "')";

            fc.ds_bar.Clear();
            rcount = fc.rs_bar.Fill(fc.ds_bar, "tblDaten");

            if (!IsNewDataSet)
            {
                if (rcount == 0)
                {
                    fc.CloseConnection();
                    return ResultWriteDataToDataBase;
                }
            }

            DataRow dr_auf = fc.ds_bar.Tables["tblDaten"].NewRow();

            if (!IsNewDataSet)
            {
                dr_auf = fc.ds_bar.Tables["tblDaten"].Select("VarField1='" + TagNr + "'")[0];
            }
            txtBox5.Text = s.ToShortTimeString();
            dr_auf["VarField1"] = TagNr;
            dr_auf["VarField2"] = txtBox2.Text;
            dr_auf["VarField3"] = txtBox3.Text;
            dr_auf["VarField4"] = txtBox4.Text;
            dr_auf["VarField5"] = txtBox5.Text;

            if (IsNewDataSet)
            {
                fc.ds_bar.Tables["tblDaten"].Rows.Add(dr_auf);
            }
            fc.rs_bar.Update(fc.ds_bar, "tblDaten");
            dr_auf = null;
            cb.Dispose();
            cb = null;
            return true;
        }

        private void GetDataFromDatabase(string TagNr)
        {
            if (!FindTAGInTable(TagNr))
            {
                DBStatus = "AddNew";
                thisDate = System.DateTime.Today;
                txtBox5.Text = thisDate.ToShortDateString();
            }
            else
            {
                DBStatus = "Edit";
            }
        }

        private void btReadTag_Click(Object sender, EventArgs e)
        {
            string TagNr = string.Empty;
            try
            {
                fc.SC(1);
                lbInfo1.Text = TagInfo;
                lbInfo1.Refresh();
                if (fc.Reader_Typ == 1)
                {
                    TagNr = fc.MyBTLF.SelectTag(fc.TagType);
                    if (fc.MyBTLF.IsTagSelect)
                    {
                        fc.PlaySound();
                        TextBoxAvtive(true);
                        txtBox1.Text = TagNr;
                        ButtonActive(2);
                        ReadTagDataLF();
                        GetDataFromDatabase(TagNr);
                        txtBox2.Focus();
                    }
                    else
                    {
                        TextBoxAvtive(false);
                        txtBox1.Text = "No Tag found";
                        ButtonActive(1);
                        lbInfo1.Text = "No " + lbInfo1.Text + " found";
                        lbInfo1.Refresh();
                    }
                }
                if (fc.Reader_Typ == 2)
                {
                    if (fc.HF_Transponder_Typ == 0) 
                    {
                        if (fc.RFID_HF.GetUID_ISO())
                        {
                            fc.PlaySound();
                            TagNr = fc.RFID_HF.UIDFeigNr_ISO;
                            TextBoxAvtive(true);
                            txtBox1.Text = TagNr;
                            ButtonActive(2);
                            ReadTagDataHF();
                            GetDataFromDatabase(TagNr);
                            txtBox2.Focus();
                        }
                        else
                        {
                            TextBoxAvtive(false);
                            txtBox1.Text = "No Tag found";
                            ButtonActive(1);
                            lbInfo1.Text = "No " + lbInfo1.Text + " found";
                            lbInfo1.Refresh();
                        }
                    }
                    if (fc.HF_Transponder_Typ == 1)
                    {
                        if (fc.RFID_HF.GetUID_MIF())
                        {
                            fc.PlaySound();
                            TagNr = fc.RFID_HF.UIDFeigNr_MIF;
                            TextBoxAvtive(true);
                            txtBox1.Text = TagNr;
                            ButtonActive(2);
                            ReadTagDataHF();
                            GetDataFromDatabase(TagNr);
                            txtBox2.Focus();
                        }
                        else
                        {
                            TextBoxAvtive(false);
                            txtBox1.Text = "No Tag found";
                            ButtonActive(1);
                            lbInfo1.Text = "No " + lbInfo1.Text + " found";
                            lbInfo1.Refresh();
                        }
                    }

                }
                if (fc.Reader_Typ == 3)
                {
                    if (fc.RFID_UHF.GetUID_Repeat())
                    {
                        fc.PlaySound();
                        TagNr = fc.RFID_UHF.UIDNr;
                        TextBoxAvtive(true);
                        txtBox1.Text = TagNr;
                        ButtonActive(2);
                        ReadTagDataUHF();
                        GetDataFromDatabase(TagNr);
                        txtBox2.Focus();
                    }
                    else
                    {
                        TextBoxAvtive(false);
                        txtBox1.Text = "No Tag found";
                        ButtonActive(1);
                        lbInfo1.Text = "No " + lbInfo1.Text + " found";
                        lbInfo1.Refresh();
                    }
                }
            }
            finally
            {
                fc.SC(0);
            }
        }

        private void frmRFIDData_Closing(object sender, System.ComponentModel.CancelEventArgs e)
        {
            fc.CloseConnection();
        }

        private void frmRFIDData_Load(object sender, EventArgs e)
        {
            TextBoxAvtive(false);
            ButtonActive(0);
            if (fc.Reader_Typ == 1)
            {
                if (fc.MyBTLF.Active)
                {
                    btReadTag.Enabled = true;
                    btWrite.Enabled = false;
                    btCancel.Enabled = false;
                    ButtonActive(1);
                }
            }
            if (fc.Reader_Typ == 2)
            {
                if (fc.RFID_HF.Active)
                {
                    btReadTag.Enabled = true;
                    btWrite.Enabled = false;
                    btCancel.Enabled = false;
                    ButtonActive(1);
                }
            }
            if (fc.Reader_Typ == 3)
            {
                if (fc.RFID_UHF.IsActive)
                {
                    btReadTag.Enabled = true;
                    btWrite.Enabled = false;
                    btCancel.Enabled = false;
                    ButtonActive(1);
                }
            }
        }

        private void ButtonActive(int Index)
        {
            switch (Index)
            {
                case 0:
                    btReadTag.Enabled = false;
                    btCancel.Enabled = false;
                    btWrite.Enabled = false;
                    DataItem.Enabled = false;
                    break;
                case 1:
                    btReadTag.Enabled = true;
                    btCancel.Enabled = false;
                    btWrite.Enabled = false;
                    DataItem.Enabled = true;
                    break;
                case 2:
                    btReadTag.Enabled = false;
                    btCancel.Enabled = true;
                    btWrite.Enabled = true;
                    break;
                case 3:
                    btReadTag.Enabled = true;
                    btCancel.Enabled = true;
                    btWrite.Enabled = true;
                    DataItem.Enabled = true;
                    break;
            }

        }

        private void TextBoxAvtive(bool Active)
        {
            txtBox1.Enabled = Active;
            txtBox2.Enabled = Active;
            txtBox3.Enabled = Active;
            txtBox4.Enabled = Active;
            txtBox5.Enabled = Active;
        }

        private void btCancel_Click(Object sender, EventArgs e)
        {
            fc.CloseConnection();
            TextBoxAvtive(false);
            ButtonActive(1);
        }

        private void ClearTextBoxes()
        {
            txtBox1.Text = "";
            txtBox2.Text = "";
            txtBox3.Text = "";
            txtBox4.Text = "";
            txtBox5.Text = "";
        }

        private void btWrite_Click(Object sender, EventArgs e)
        {
            string TagNr = string.Empty;
            try
            {
                btWrite.Enabled = false;
                fc.SC(1);
                TagNr = txtBox1.Text;
                if (fc.Reader_Typ == 1)
                {
                    WriteTagDataLF();
                    WriteDataToDataBase(TagNr);
                    ClearTextBoxes();
                    TextBoxAvtive(false);
                    ButtonActive(1);
                    fc.PlaySound();
                }
                if (fc.Reader_Typ == 2)
                {
                    WriteTagDataHF();
                    WriteDataToDataBase(TagNr);
                    ClearTextBoxes();
                    TextBoxAvtive(false);
                    ButtonActive(1);
                    fc.PlaySound();
                }
                if (fc.Reader_Typ == 3)
                {
                    WriteTagDataUHF();
                    WriteDataToDataBase(TagNr);
                    ClearTextBoxes();
                    TextBoxAvtive(false);
                    ButtonActive(1);
                    fc.PlaySound();
                }
            }
            finally
            {
                //btWrite.Enabled = True
                fc.SC(0);
            }
        }

   }
}